/**
 * COMP 401 Fall 2017 -- Recitation 29 September 2017
 * 
 * Copyright (C) 2017, Alex Blate. All Rights Reserved.
 */
package recitations.recitation8;

import java.awt.BasicStroke;
import java.awt.Stroke;


public class AStrokedLine extends ALine implements StrokedLine {

	protected BasicStroke stroke;


	public AStrokedLine(int initX, int initY,
		int initWidth, int initHeight, float strokeWidth) {

		super(initX, initY, initWidth, initHeight);
		changeStrokeWidth(strokeWidth);
	}
	
	public AStrokedLine(StrokedLine other) {
		super(other);
		changeStrokeWidth(other.getStrokeWidth());
	}

	@Override
	public double getStrokeWidth() {
		if(null != stroke) {
			return (double) stroke.getLineWidth();
		} else {
			return 0;
		}
	}

	@Override
	public void changeStrokeWidth(double width) {
		// Hack because AWT requires float but ObjectEditor doesn't
		// like float (it likes double)
		setStroke(new BasicStroke((float) width));
	}

	public void setStrokeWidth(double width) {
		changeStrokeWidth(width);
	}

	// for oe
	protected void setStroke(BasicStroke stroke) {
		this.stroke = stroke;
	}

	@Override
	public Stroke getStroke() {
		return this.stroke;
	}



}// class
