/**
 * COMP 401 Fall 2017 -- Recitation 29 September 2017
 * 
 * Copyright (C) 2017, Alex Blate. All Rights Reserved.
 */
package recitations.recitation8;

public class AnAutoScaledStrokedLine extends AStrokedLine implements HasLength {

	public AnAutoScaledStrokedLine(int initX, int initY, int initWidth, int initHeight, float strokeWidth) {
		super(initX, initY, initWidth, initHeight, strokeWidth);
	}

	//Copy CTOR
	public AnAutoScaledStrokedLine(AStrokedLine other) {
		super(other);
	}


	@Override
	public double getLength() {
		return Math.hypot(getWidth(), getHeight());
	}

	protected double computeNewStrokeWidth(double oldLength, double newLength) {

		if (getStroke() == null) {
			return 1.0;
		} else if (oldLength != 0) {
			return getStrokeWidth() * (newLength / oldLength);
		} else {
			return getStrokeWidth();
		}
	}

	// Assumes dimensions have already been changed
	protected double updateStrokeWidth(double oldLength) {
		double currentLength = getLength();
		double newStrokeWidth = computeNewStrokeWidth(oldLength, currentLength);
		setStrokeWidth(newStrokeWidth);
		return getStrokeWidth();
	}

	@Override
	public void setX(int newX) {
		double oldLength = getLength();
		super.setX(newX);
		updateStrokeWidth(oldLength);
	}

	@Override
	public void setY(int newY) {
		double oldLength = getLength();
		super.setY(newY);
		updateStrokeWidth(oldLength);

	}

	@Override
	public void setWidth(int newVal) {
		double oldLength = getLength();
		super.setWidth(newVal);
		updateStrokeWidth(oldLength);
	}

	@Override
	public void setHeight(int newHeight) {
		double oldLength = getLength();
		super.setHeight(newHeight);
		updateStrokeWidth(oldLength);
	}

}
