/**
 * COMP 401 Fall 2017 -- Recitation 13 October 2017
 * 
 * Copyright (C) 2017, Alex Blate. All Rights Reserved.
 */
package recitations.recitation8;

import java.beans.PropertyChangeListener;
import java.beans.PropertyChangeSupport;


public class AnObservableStrokedLine extends AStrokedLine implements ListenableStrokedLine {

	//Helper class from the platform libraries; deals with managing listeners 
	//and dispatching events.
	protected PropertyChangeSupport	propertyListenerSupport	= null;


	public AnObservableStrokedLine(int initX, int initY, int initWidth, int initHeight, float strokeWidth) {
		super(initX, initY, initWidth, initHeight, strokeWidth);
		propertyListenerSupport = new PropertyChangeSupport(this);
	}

	public AnObservableStrokedLine(StrokedLine other) {
		super(other);
		propertyListenerSupport = new PropertyChangeSupport(this);
	}


	@Override
	public void addPropertyChangeListener(PropertyChangeListener listener) {		
		propertyListenerSupport.addPropertyChangeListener(listener);
	}
	
	@Override
	public void removePropertyChangeListener(PropertyChangeListener listener) {
			propertyListenerSupport.removePropertyChangeListener(listener);	
	}


	@Override
	public void changeStrokeWidth(double width) {
		double oldWidth = getStrokeWidth();

		super.changeStrokeWidth(width);

		//POI #6
		if (null != propertyListenerSupport) {
			propertyListenerSupport.firePropertyChange(PROPERTY_STROKE_WIDTH, oldWidth, getStrokeWidth());
		}
	}


	@Override
	public void setStrokeWidth(double width) {
		this.changeStrokeWidth(width);
	}


	@Override
	public void setX(int newX) {
		int old = getX();
		super.setX(newX);
		if (null != propertyListenerSupport) {
			propertyListenerSupport.firePropertyChange(PROPERTY_X, old, getX());
		}
	}


	@Override
	public void setY(int newY) {
		int old = getY();
		super.setY(newY);
		if (null != propertyListenerSupport) {
			propertyListenerSupport.firePropertyChange(PROPERTY_Y, old, getY());
		}
	}


	@Override
	public void setWidth(int newVal) {
		int old = getWidth();
		super.setWidth(newVal);
		if (null != propertyListenerSupport) {
			propertyListenerSupport.firePropertyChange(PROPERTY_WIDTH, old, getWidth());
		}
	}


	@Override
	public void setHeight(int newHeight) {
		int old = getHeight();
		super.setHeight(newHeight);
		if (null != propertyListenerSupport) {
			propertyListenerSupport.firePropertyChange(PROPERTY_HEIGHT, old, getHeight());
		}
	}


}
