/**
 * COMP 401 Fall 2017 -- Recitation 13 October 2017
 * 
 * Copyright (C) 2017, Alex Blate. All Rights Reserved.
 */

package recitations.recitation8;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Objects;



public class LineMoverAction implements ActionListener {

	protected Line			line		= null;
	protected MoveDirection	direction	= null;
	protected int			increment	= 0;

	public LineMoverAction(Line line, MoveDirection direction, int increment) {
		Objects.requireNonNull(line);
		Objects.requireNonNull(direction);
		this.line = line;
		this.direction = direction;
		this.increment = increment;
	}
	
	@Override
	public void actionPerformed(ActionEvent e) {
		
		switch (direction) {
			case DOWN:
				line.setY(line.getY() + increment);
				break;
			case LEFT:
				line.setX(line.getX()-increment);
				break;
			case RIGHT:
				line.setX(line.getX()+increment);
				break;
			case UP:
				line.setY(line.getY() - increment);
				break;
			default:
				throw new RuntimeException("This line of code should never be executed.");
		}

	}
}
