/**
 * COMP 401 Fall 2017 -- Recitation 27 October 2017
 * 
 * Copyright (C) 2017, Alex Blate. All Rights Reserved.
 */

package recitations.recitation9MVC;

import javax.swing.JFrame;

import bus.uigen.CompleteOEFrame;
import bus.uigen.ObjectEditor;
import javafx.application.Application;
import javafx.scene.Group;
import javafx.scene.Scene;
import javafx.stage.Stage;
import recitations.recitation8.AStrokedLine;
import recitations.recitation8.AnObservableStrokedLine;
import recitations.recitation8.AppDemo1;
import recitations.recitation8.ConsoleListener;
import recitations.recitation8.ListenableStrokedLine;
import recitations.recitation8.StrokedLine;

/**
 * @see javafx.application.Application
 * @author blate
 *
 */
public class AppDemo2 extends Application {

	public static final int		WINDOW_HEIGHT			= 400;
	public static final int		WINDOW_WIDTH			= 400;
	public static final int		INITIAL_X				= 100;
	public static final int		INITIAL_Y				= 100;
	public static final int		INITIAL_WIDTH			= 100;
	public static final int		INITIAL_HEIGHT			= 100;
	public static final float	INITIAL_STROKE_WIDTH	= 5F;
	public static String		windowTitle				= "Line Viewer";
	public static String		controlTitle			= "Line Control";


	public void start(Stage stage) {
		StrokedLine strokedLine =
			new AStrokedLine(INITIAL_X, INITIAL_Y, INITIAL_WIDTH, INITIAL_HEIGHT, INITIAL_STROKE_WIDTH);
		ListenableStrokedLine oStrokedLine = new AnObservableStrokedLine(strokedLine);

		HasShape lineView = new StrokedLineView(oStrokedLine);

		Group root = new Group();

		Scene scene = new Scene(root, WINDOW_WIDTH, WINDOW_HEIGHT);
		root.getChildren().add(lineView.getShape());

		stage.setScene(scene);
		showAndFormatStage(stage);

		//POI #10
		//Reuse existing control stuff
		JFrame frame = AppDemo1.createLineControl(oStrokedLine, controlTitle);
		frame.setVisible(true);

		CompleteOEFrame oeFrame = ObjectEditor.edit(oStrokedLine);
		oeFrame.setSize(WINDOW_WIDTH, WINDOW_HEIGHT);		
		
	}


	protected void showAndFormatStage(Stage stage) {
		stage.show();
		stage.setHeight(WINDOW_HEIGHT);
		stage.setWidth(WINDOW_WIDTH);
		stage.setX(WINDOW_WIDTH);
		stage.setY(WINDOW_HEIGHT);
		stage.setTitle(windowTitle);
	}


	public static void main(String[] args) {
		Application.launch(AppDemo2.class, args);
	}

}
