
/**
 * COMP 401 Fall 2017 -- Recitation 13 October 2017
 * 
 * Copyright (C) 2017, Alex Blate. All Rights Reserved.
 */

package recitations.recitation9MVC;

import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;

import javafx.scene.shape.Line;
import javafx.scene.shape.Shape;
import recitations.recitation8.ListenableStrokedLine;


public class StrokedLineView implements PropertyChangeListener, HasShape {

	protected ListenableStrokedLine strokedLine;
	protected Line drawnLine;


	public StrokedLineView(ListenableStrokedLine strokedLine) {
		this.strokedLine=strokedLine;
		strokedLine.addPropertyChangeListener(this);
		drawnLine = new Line();
		this.updateDrawnLine();
	}
	
	protected void updateDrawnLine() {
		updateDrawnLineXCoordinates();
		updateDrawnLineYCoordinates();				
		updateDrawnLineStrokeWidth();		
	}

	protected void updateDrawnLineStrokeWidth() {
		drawnLine.setStrokeWidth(strokedLine.getStrokeWidth());
	}

	protected void updateDrawnLineYCoordinates() {
		drawnLine.setStartY(strokedLine.getY());
		drawnLine.setEndY(strokedLine.getY()+ strokedLine.getHeight());
	}

	protected void updateDrawnLineXCoordinates() {
		drawnLine.setStartX(strokedLine.getX());
		drawnLine.setEndX(strokedLine.getX()+strokedLine.getWidth());
	}
	
	@Override
	public Shape getShape() {
		return this.drawnLine;
	}
	
	@Override
	public void propertyChange(PropertyChangeEvent evt) {
		String property = evt.getPropertyName();
	
		switch(property) {
			case ListenableStrokedLine.PROPERTY_HEIGHT:
			case ListenableStrokedLine.PROPERTY_Y: {
				updateDrawnLineYCoordinates();
				break;
			}
			case ListenableStrokedLine.PROPERTY_WIDTH:
			case ListenableStrokedLine.PROPERTY_X: {
				updateDrawnLineXCoordinates();
				break;
			}
			
			case ListenableStrokedLine.PROPERTY_STROKE_WIDTH: {
				System.out.println("Stroke width notification");
				updateDrawnLineStrokeWidth();		
				break;
			}
			default: {
				System.err.println("StrokedLineView.propertyChange(): Unexpected property " + property + " ignored");
			}
		}
		
	}

}
